unit Unit1;

{$mode objfpc}{$H+}

interface

uses
  Classes, SysUtils, Forms, Controls, Graphics, Dialogs, StdCtrls;

type

  { TForm1 }

  TForm1 = class(TForm)
    Button1: TButton;
    Edit1: TEdit;
    Edit2: TEdit;
    Edit3: TEdit;
    Label1: TLabel;
    Label2: TLabel;
    Label3: TLabel;
    procedure Button1Click(Sender: TObject);
  private
    function ValidInput(out AControl: TWinControl; out AErrMsg: string): Boolean;

  public

  end;

var
  Form1: TForm1;

implementation

{$R *.lfm}

{ TForm1 }

procedure TForm1.Button1Click(Sender: TObject);
var
  C: TWinControl;
  msg: String;
begin
  if ValidInput(C, msg) then
    ShowMessage('Everything is ok. Update is executed...')
  else begin
    C.SetFocus;
    MessageDlg(msg, mtError, [mbOK], 0);
  end;
end;

function TForm1.ValidInput(out AControl: TWinControl; out AErrMsg: string): Boolean;
var
  i: Integer;
  d: TDate;
begin
  Result := false;
  if not TryStrToInt(Edit1.Text, i) then begin
    AControl := Edit1;
    AErrMsg := 'This is not a valid integer.';
    exit;
  end;

  for i := 1 to Length(Edit2.Text) do
    if not (Edit2.Text[i] in ['a'..'z', 'A'..'Z']) then begin
      AControl := Edit2;
      AErrMsg := 'Only alphanumeric characters are allowed here.';
      exit;
    end;

  if not TryStrToDate(Edit3.Text, d) then begin
    AControl := Edit3;
    AErrMsg := 'This is not a valid date.';
    exit;
  end;

  Result := true;
end;

end.
